// implementatino of the Time class with input and output operators

#include "timeio.h"

istream& operator>>(istream& inS, Time& t)
{
	char ch;

	inS >> t.hours;
	inS.get(ch);

	inS >> t.minutes ;
	inS.get(ch);

	inS>> t.seconds;
	inS.ignore(80,'\n');

	t.hours %= 24;		// make sure time is valid
	t.minutes %= 60;
	t.seconds %= 60;

	return inS;
}


ostream& operator<<(ostream& outS, const Time& t)
{
  outS << t.hours << ":";
  if (t.minutes < 10)
    outS << '0';
  
  outS << t.minutes << ":" ;

  if (t.seconds < 10)
    outS << '0';

  outS << t.seconds << endl;

  return outS;
}	



Time::Time()
{
	hours = 12;
	minutes = seconds = 0;
}


Time::Time(int newHours, int newMinutes, int newSeconds)
{
  hours = newHours % 24;
  minutes = newMinutes % 60;
  seconds = newSeconds % 60;
}

void Time::Set(int newHours, int newMinutes, int newSeconds)
// pre: assume hours, minutes, seconds are valid.

{
  hours = newHours % 24;
  minutes = newMinutes % 60;
  seconds = newSeconds % 60;
}

void Time::Add(Time& otherTime)
{
  hours = (hours + otherTime.hours);
  minutes = (minutes + otherTime.minutes);
  seconds = (seconds + otherTime.seconds);

  if (seconds / 60)
  {
    minutes++;
    seconds -= 60;
  }
  if (minutes / 60)
  {
    hours++;
    minutes -= 60;
  }

  hours %= 24;
}

void Time::Increment()
{
  seconds++;

  if (seconds == 60)
  {
    seconds = 0;
    minutes++;
  }

  if (minutes==60)
  {
    minutes=0;
    hours++;
  }

  if (hours==24)
  {
    hours=0;
  }
}
