// search through a bunch of numbers for a given value
// it requires sortednumbers.txt, which contains 50000 random numbers.

#include <iostream>
#include <fstream>
using namespace std;

#include "misc.h";

int binsearch(int array[], int size, int target, int& numComps)
//PRE: array[] must be sorted!!
//POST:  if the target was in the array, its position will be returned.
//       if not, the function will return -1.

{
  int low = 0, high = size-1, middle;
  numComps = 0;

  while (low <= high)
  {
    middle = (high + low) / 2;

    cout << "low index = " << low << ", high index = " << high << 
		", middle index= " << middle << endl;

    cout << "low value = " << array[low] << ", high value = " << array[high] << 
		", middle value= " << array[middle] << endl;

	pause();

    numComps++;

    if (target > array[middle])
		low = middle + 1;
	else if (target < array[middle])
		high = middle - 1;
    else if (target == array[middle])
		return middle;

  }

  return -1;
}

int main()
{
  ifstream inFile("sortednumbers.txt");
  int numbers[60000], result, target;
  int size = 0, numComparisons;
  char yesNo;


  while (inFile >> numbers[size++]);

  do
  {
    cout << "Enter a number to search for: ";
    cin >> target;  cin.ignore(80,'\n');

    result = binsearch(numbers, size-1, target, numComparisons);

    switch (result)
    {
	case -1:
		cout << "Target was not found in the array.\n";
		break;
	default:
		cout << "Target was found in the array at pos. " << result << ".\n";

		cout << "It was found in " << numComparisons << " tries." << endl;
		break;
    }

    cout << "Search again? ";
    cin >> yesNo;
  }

  while (yesNo == 'y');

}
