#include <iostream.h>
#include <math.h>

void secant(double, double, double, int); // function prototype
double f(double); // function prototype

int main()
{
  int imax;          // maximum number of iterations
  double a, b;       // left and right ends of the original interval
  double epsilon;    // convergence criterion
	
  // obtain the input data
  cout << "Enter the limits of the original search interval, a and b: ";
  cin  >> a >> b;
  cout << "Enter the convergence criteria: ";
  cin  >> epsilon;
  cout << "Enter the maximum number of iterations allowed: ";
  cin  >> imax;

  secant(a, b, epsilon, imax);

  return 0;
}

// This function implements the secant method for finding
// a root of a function
void secant(double a, double b, double epsilon, int imax)
{
  
  int i;             // current iteration counter
  double x0, x1;     // left and right x values of current interval
  double f0, f1;     // function evaluated at these points
  double dx0;        // delta x0
  double dx1;        // delta x1

  // echo back the passed input data
  cout << "\nThe original search interval is from " << a << " to " << b 
       << "\nThe convergence criterion is: interval < "  << epsilon  
       << "\nThe maximum number of iterations allowed is " << imax << endl;

  // determine the root
  x0 = a;
  f0 = f(x0);
  dx0 = fabs(b - a);
  
  // iterations
  for (i = 1; i <= imax; i++)
  {
    x1 = x0 + dx0;
    f1 = f(x1);
    if (fabs(f1) < epsilon) // root is found
    {
      cout << "\nA root at x = " << x1 + dx1 << " was found " 
	    << "in " << i << " iterations" << endl;
      cout << "The value of the function is " << f1 << endl;
      return;
    }
    else  // do next iteration
    {
      dx1 = ( f1/(f0 - f1) ) * dx0;
      x0 = x1;
      dx0 = dx1;
      f0 = f1;
    }
  }
  cout << "\nAfter " << imax << " iterations, no root was found "
       << "within the convergence criterion\n" 
       << "The search for a root has failed due to excessive iterations\n"
	<< "after the maximum number of " << imax << " iterations" << endl;
		
  return;
}

// function to evaluate f(x)
double f(double x)
{
	const double PI = acos(-1);  // value of pi

	return (exp(-x) - sin(0.5 * PI * x));
}
