// Filenme: TCLASS.CPP
// Purpose: Illustrates a simple class for representing time.

#include <iostream>
using namespace std;


class Time
{
public:
    void Set(/* in */ int hoursNew,
             /* in */ int minutesNew,
             /* in */ int secondsNew);
    // Pre:  0 <= hoursNew   <= 23
    //       0 <= minutesNew <= 59
    //       0 <= secondsNew <= 59
    // Post: Time is set according to the incoming parameters.
    // Note that this function must be called prior to a call
    // to any other member function.

    void Increment();
    // Pre:  The Set function has been called at least once.
    // Post: Time has been advanced by one second, with
    //       23:59:59 wrapping around to 0:0:0.

    void Display() const;
    // Pre:  The Set function has been called at least once.
    // Post: Time has been output in the form HH:MM:SS.

private:
    int hours;
    int minutes;
    int seconds;
};



int main()
{
    cout << endl
         << "This program illustrates the use of "
         << "a simple class for representing time. "  << endl
         << "You should study the source code "
         << "at the same time as the output. "        << endl
         << endl;

    Time t1;
    Time t2;

    t1.Set(11, 59, 50);
    t2.Set(12, 0, 0);

    t1.Display();  cout << endl;
    t2.Display();  cout << endl;

    cout << endl;

    for (int i = 1; i <= 11; i++)
    {
        t1.Display();  cout << endl;
        t1.Increment();
    }

    cout << endl;

    return 0;
}


//******************************************************************
void Time::Set(/* in */ int hoursNew,
               /* in */ int minutesNew,
               /* in */ int secondsNew)
// Pre:  0 <= hoursNew <= 23
//       0 <= minutesNew <= 59
//       0 <= secondsNew <= 59
// Post: Time is set according to the incoming parameters.
// Note that this function MUST have been called prior to
// any call to *any* of the other member functions.
{
    hours = hoursNew;
    minutes = minutesNew;
    seconds = secondsNew;
}



//******************************************************************
void Time::Increment()
// Pre:  The Set function has been called at least once.
// Post: Time has been advanced by one second, with
//       23:59:59 wrapping around to 0:0:0.
{
    seconds++;
    if (seconds > 59)
    {
        seconds = 0;
        minutes++;
        if (minutes > 59)
        {
            minutes = 0;
            hours++;
            if (hours > 23)
                hours = 0;
        }
    }
}



//******************************************************************
void Time::Display() const
// Pre:  The Set function has been called at least once.
// Post: Time has been output in the form HH:MM:SS.
{
    if (hours < 10)
        cout << '0';
    cout << hours << ':';
    if (minutes < 10)
        cout << '0';
    cout << minutes << ':';
    if (seconds < 10)
        cout << '0';
    cout << seconds;
}
