// Filename: TIME2.H
// Purpose:  Extends the class in TIME1.H by adding two constructors.

#ifndef _TIME2_H_
#define _TIME2_H_

class Time
{
public:

    Time();
    // Default constructor
    // Pre:  none
    // Post: Class object is constructed and the time is 00:00:00.
    //       That is, hours, minutes and seconds all have value 0.

    Time(/* in */ int hoursInitial,
         /* in */ int minutesInitial,
         /* in */ int secondsInitial);
    // Constructor
    // Pre:      0 <= hoursInitial   <= 23
    //           0 <= minutesInitial <= 59
    //       and 0 <= secondsInitial <= 59
    // Post: Class object is constructed.
    //       The time is set according to the incoming parameters.


    void Set(/* in */ int hoursNew,
             /* in */ int minutesNew,
             /* in */ int secondsNew);
    // Pre:  0 <= hoursNew   <= 23
    //       0 <= minutesNew <= 59
    //       0 <= secondsNew <= 59
    // Post: Time is set according to the incoming parameters.

    void Increment();
    // Pre:  none
    // Post: Time has been advanced by one second, with
    //       23:59:59 wrapping around to 00:00:00.

    void Display() const;
    // Pre:  none
    // Post: Time has been output in the form HH:MM:SS.


private:

    int hours;
    int minutes;
    int seconds;
};

#endif

