// Filename: PTR_EX6.CPP
// Purpose:  Illustrates dynamic storage with both simple and array
//           variables, as well as "new" and "delete", and the NULL pointer.

#include <iostream>
#include <cstddef>
using namespace std;

#include "PAUSE.H"

int main()
{
    cout << "\nThis program illustrates dynamic storage "
         << "with new, delete and NULL."
         << "\nStudy the source code and the output simultaneously.\n\n";

    int* iPtr1;        // Declare pointer to int.
    iPtr1 = new int;   // Make pointer point to a (dynamic) int location.
    *iPtr1 = 34;       // Put a value (34) in that (dynamic) location.

    int* iPtr2 = new int; // Declare int pointer/allocate memory at same time.
    *iPtr2 = 12;          // Put a value (12) in that (dynamic) location.

    // Display the two values.
    cout << *iPtr1 << " " << *iPtr2 << endl;
    Pause(0);

    delete iPtr1;  // Return storage pointed to by iPtr1 to free store.
    iPtr1 = iPtr2; // Make iPtr1 point at storage pointed to by iPtr2.
    iPtr2 = NULL;  // Make iPtr2 point at nothing at all.
    // Note that at this point we have "lost" 34.


    // Create a dynamic int array of size 6 pointed to by a.
    int* a = new int[6];

    int i;
    for (i = 0; i < 6; i++)  // Put some values in the array.
        a[i] = i*i*i;
    for (i = 0; i < 6; i++)  // Display the values in the array.
        cout << a[i] << " ";
    cout << endl;
    Pause(0);

    a[5] = *iPtr1;           // Change one of the values in the array.
    for (i = 0; i < 6; i++)  // Display the array values again.
        cout << a[i] << " ";
    cout << endl;
    Pause(0);

    delete [] a;  // Return the array storage to the free store.

    return 0;
}
