// BankAccount  class

#include <iostream>
using namespace std;

#include "bankaccount1.h"

BankAccount::BankAccount()
{
	balance = 0;
}


BankAccount::BankAccount(double amt)
{
	balance = amt;
}


bool BankAccount::Deposit(double amt)
{
	if(amt < 0)
		return false;
	else
	{
		balance += amt;
		return true;
	}
}

bool BankAccount::Withdraw(double amt)
{
	if(amt < 0 || amt > balance)
		return false;
	else
	{
		balance -= amt;
		return true;
	}
}

bool BankAccount::Transfer(BankAccount& b, double amt)
{
	if (b.Withdraw(amt))	// since this function does not access
	{			// private members directly, it could
		Deposit(amt);	// have been written separate from the
		return true;	// class
	}
	else
		return false;
}

double BankAccount::CheckBalance()
{
	return balance;
}

void BankAccount::OutputBalance()	// output using $, with "Magic Formula"
{
	cout.setf(ios::showpoint);
	cout.setf(ios::fixed);
	cout.precision(2);

	cout << "$" << balance << endl;
}

void BankAccount::PrintHeader(ostream& out)
{
    out << "The Balance is:  " << endl;
}

istream& operator>>(istream& inS, BankAccount& b)
{
    inS >> b.balance;

    return inS;
}
ostream& operator<<(ostream& outS, const BankAccount& b)
{
   	outS.setf(ios::showpoint);
	outS.setf(ios::fixed);
	outS.precision(2);

	outS << "$" << b.balance << endl;

    return outS;
}



