#include <iostream>
#include <iomanip>
using namespace std;

struct Node
{
	double data;
	Node *link;
};
typedef Node* NodePtr;

void BuildSequenceFixedSize(NodePtr& head);
void PrintNodeValues(NodePtr& head);
void Pause();

void main(void)
{
		cout << "===================================================" << endl
		 << "Program Name: buildSeq.cpp" << endl
		 << "Name: Jing Xu" << endl
		 << "Student ID: 9999999" << endl
		 << "Class Number: CSC301" << endl << endl
		 << "Lab 9, 9-2" << endl
		 << "==================================================" << endl;
	cout << endl;


	NodePtr head;

	BuildSequenceFixedSize(head);
	PrintNodeValues(head);
	Pause();
}

void BuildSequenceFixedSize(NodePtr& head)
// Pre:  none
// Post: The user has entered the number of nodes to be in a
//       newly constructed sequence, as well as the values to
//       be inserted into the sequence, the sequence has been
//       constructed, and "head" points at the first node.
//       All storage in any sequence previously pointed to by
//       "head" has been returned to the free store.
{
    int numNodes;
    int nodeCounter;
    NodePtr current;
    NodePtr next;

    cout << "Enter number of nodes in the sequence: ";
    cin  >> numNodes;  cin.ignore(80, '\n');
    cout << endl;
    cout << "Now enter the node values for the sequence "
         << "on the following line: (please do not enter 0)" << endl;

    head = new Node;
    cin >> head->data;
    current = head;

    for (nodeCounter = 2; nodeCounter <= numNodes; nodeCounter++)
    {
        next = new Node;
        cin >> next->data;
        current->link = next;
        current = next;
    }
    cin.ignore(80, '\n');
    current->link = NULL;
}

void PrintNodeValues(/* inout */ NodePtr& head)
// Pre:  "head" has been initialized.
// Post: If the sequence is empty, a message to that effect has
//       been output.  Otherwise, all values in the sequence
//       pointed to by "head" have been displayed, ten to a line,
//       with each one in a field width of six spaces.
{
    NodePtr current;
    int nodeCounter;

    if (head == NULL)
        cout << "No values to print.  Current sequence is empty. "
             << endl;
    else
    {
        cout << "Here are the current data values in the sequence: "
             << endl;
        current = head;
        nodeCounter = 0;
        while (current != NULL)
        {
            cout << setw(6) << current->data;
            nodeCounter++;
            if (nodeCounter % 10 == 0) cout << endl;
            current = current->link;
        }
        if (nodeCounter % 10 != 0) cout << endl;
    }
    cout << endl;
}

void Pause()
{
    cout << "Press ENTER to continue ... ";
    char returnChar;
    cin.get(returnChar);
    cout << endl;
}
