// program that computes the average of a set of doubles in a file.
// this version expects that the first number in the file is an integer
// which represents the number of doubles in the file.
// written by Jean-Paul Deveaux


#include <iostream>
#include <fstream>
using namespace std;

int main()
{
  int numDoubles;
  double current, sum, average;
  ifstream inFile;
  ofstream outFile;

  inFile.open("num1.txt");

  if (inFile.fail())
  {
    cerr << "Problem with input file.\n";
    exit(0);
  }

  outFile.open("res1.txt");

  if (outFile.fail())
  {
    cerr << "Problem with output file.\n";
    exit(0);
  }

  sum = 0;

  inFile >> numDoubles;

  for (int i=0;i<numDoubles;i++)
  {
    inFile >> current;
    sum += current;
  }

  average = sum / numDoubles;

  cout << "Input file processed..." << endl;

  outFile << "There were " << numDoubles << " numbers in the file.\n";

  outFile.setf(ios::fixed);
  outFile.setf(ios::showpoint);
  outFile.precision(2);

  outFile << "The average of those doubles is " << average << endl;

  cout << "Output file created.\n";

  inFile.close();
  outFile.close();

  return 0;
}
