// program that computes the average of a set of doubles in a file.
// written by Jean-Paul Deveaux


#include <iostream>
#include <fstream>
#include <string>
using namespace std;

int main()
{
  int numDoubles;
  double current, sum, average;
  string inFileName = "num2.txt", outFileName = "res2.txt";

  ifstream inFile(inFileName.c_str());

  if (inFile.fail())
  {
    cerr << "Problem with input file.\n";
    exit(0);
  }

  ofstream outFile;
  outFile.open(outFileName.c_str());
  if (outFile.fail())
  {
    cerr << "Problem with output file.\n";
    exit(0);
  }

  sum = numDoubles = 0;

  inFile >> current;

  while (inFile)		// while there was no problem with the
  {				// last "file-related" command
    sum += current;
    numDoubles++;
    inFile >> current;
  }

  average = sum / numDoubles;

  cout << "Input file processed..." << endl;

  outFile << "There were " << numDoubles << " numbers in the file.\n";

  outFile.setf(ios::fixed);
  outFile.setf(ios::showpoint);
  outFile.precision(2);

  outFile << "The average of those doubles is " << average << endl;

  cout << "Output file created.\n";

  inFile.close();
  outFile.close();

  return 0;
}
