// Filename: PAUSE.CPP
// Purpose:  Causes a program to pause and wait for a user response.

#ifndef PAUSE_CPP
#define PAUSE_CPP

#include <iostream>
#include <iomanip>
using namespace std;

//******************************************************************
void Pause(/* in */ int indentLevel)
// Pre:  indentLevel has been initialized.
//       The input stream cin is empty.
// Post: The program has paused and displayed a one-line message
//       indented indentLevel spaces, after which the user has
//       pressed the ENTER key.
{
    cout << setw(indentLevel) << ""
         << "Press ENTER to continue ... ";
    char returnChar;
    cin.get(returnChar);
    cout << endl;
}

#endif