#include "salesperson.h"

void SalesPerson::printHeader(ostream& out)
{
	out << "-----------------------------------"
		<< "----------------" << endl;
	out << "Name\tSales\t\tCommission\tGrade" << endl;
	out << "-----------------------------------"
		<< "----------------" << endl;
}

SalesPerson::SalesPerson()
{
	name = "";
	sales = 0;
	commission = 0;
	grade = 'N';
}

ostream& operator<<(ostream& out, const SalesPerson& s)
{
	out.setf(ios::fixed);
	out.setf(ios::showpoint);
	out.precision(2);

	out << s.name << "\t$"
		<< s.sales << "\t$"
		<< s.commission << "\t"
		<< s.grade;
	return out;
}

istream& operator>>(istream& in, SalesPerson& s)
{
	in >> s.name >> s.sales; in.ignore(100,'\n');

	s.commission = s.sales * 0.1;
	if(s.sales >= 500000) s.grade = 'A';
	else if(s.sales >= 250000) s.grade = 'B';
	else if(s.sales >= 100000) s.grade = 'C';
	else if(s.sales >= 50000) s.grade = 'D';
	else s.grade = 'I';
	return in;
}

bool operator<(const SalesPerson& left,const SalesPerson& right)
{
    if(left.name < right.name)
		return true;
	else
		return false;
}


