// search through a bunch of numbers for a given value
// there are many different versions of the sequential search algorithm...
// I'll present two different algorithms for your perusal.

// please note that from the user's point of view, both functions work   
// in exactly the same manner:  they take an array, the size, and a 
// target as parameters, and return either a) the position in the array
// at which the first occurrence of target was found, or -1 if it was 
// not found.

#include <iostream>
#include <fstream>
using namespace std;


int search(int array[], int size, int target)
{
  int i = 0;

  for (i=0;i<size;i++)
  {
    if (array[i] == target)
	    return i;
  }

  return -1;
}

/*
int search(int array[], int size, int target)
{
  bool found = false;
  int position = 0;

  while (!found && position < size)
  {
    if (array[position]==target)
      found = true;
    else
      position++;
  }

  if (found)
    return position;
  else
    return -1;
}*/


int main()
{
  ifstream inFile("numbers.txt");
  int numbers[100];
  int size = 0;
  char yesNo;
  int target, result;


  while (inFile >> numbers[size++]);

  do
  {
    cout << "Enter a number to search for: ";
    cin >> target;  cin.ignore(80,'\n');

    result = (search(numbers, size, target));

    switch (result)
    {
	case -1:
		cout << "Target was not found in the array.\n";
		break;
	default:
		cout << "Target was found in the array at position " 
			<< result+1 << ".\n";
    }

    cout << "Search again? ";
    cin >> yesNo; cin.ignore(80,'\n');
  }

  while (yesNo == 'y');

}
