// Filenme: TESTIME2.CPP
// Purpose: Illustrates a simple time class, with the class accessed from a
//          separate header (.H) file and separately compiled object (.OBJ)
//          file.  This driver tests the version of the Time class containing
//          two constructors, and two other (non-member) functions.

#include <iostream>
using namespace std;


#include "TIME.H"
#include "PAUSE.H"


void GetTimeFromUser(Time&);
Time IncrementedTime(const Time&, int);


int main()
{
    cout << endl
         << "This program illustrates the Time class "
         << "with constructors, plus two non-member "   << endl
         << "functions.  You should study the source "
         << "code at the same time as the output. "     << endl << endl;

    Time t1(11, 14, 57);
    Time t2;
    t1.Display();  cout << endl;
    t2.Display();  cout << endl;
    Pause(0);

    Time t3 = t1;
    Time t4;
    for (int i = 1; i <= 3; i++)
        t1.Increment();
    t4 = t1;
    t3.Display();  cout << endl;
    t4.Display();  cout << endl;
    Pause(0);

    Time myTime;
    GetTimeFromUser(myTime);
    myTime.Display();  cout << endl;
    Pause(0);

    int numberOfSeconds;
    cout << "Enter a number of seconds to increment the time: ";
    cin >> numberOfSeconds;  cin.ignore(80, '\n');  cout << endl;
    Time yourTime = IncrementedTime(myTime, numberOfSeconds);
    yourTime.Display();  cout << endl;
    Pause(0);

    IncrementedTime(yourTime, 5).Display();  cout << endl;

    return 0;
}


void GetTimeFromUser(/* out */ Time& t)
// Pre:  none
// Post: "t" contains a time value entered by the user from the keyboard.
{
    int hours;
    int minutes;
    int seconds;

    cout << endl;
    cout << "Enter the hours, minutes and "
         << "seconds for a time. "               << endl
         << "Enter the values in that order, "
         << "separated by a blank space: ";
    cin >> hours >> minutes >> seconds; cin.ignore(80, '\n'); cout << endl;

    t.Set(hours, minutes, seconds);
}


Time IncrementedTime(/* in */ const Time& t,
                     /* in */ int numberOfSeconds)
// Pre:  "t" contains a valid time value.
// Post: The return-value of the function is the time value obtained
//       by incrementing "t" by numberOfSeconds seconds.  The value
//       of "t" itself is unchanged.
{
    Time tempTime = t;
    for (int i = 1; i <= numberOfSeconds; i++)
        tempTime.Increment();
    return tempTime;
}
