// Filenme: TESTIME4.CPP
// Purpose: Tests the Time class in TIME4.H and TIME4.CPP, which
//          has a four-in-one constructor, accessor functions,
//          friend functions, and overloaded operators.

#include <iostream>
#include <fstream>
#include <iomanip>
using namespace std;

#include "T4.H"
#include "PAUSE.H"


int main()
{
    cout << endl
         << "This program tests the Time class with "
         << "a four-in-one constructor, "             << endl
         << "accessor functions, friend functions, "
         << "and overloaded operators. "              << endl
         << "You should study the source code "
         << "at the same time as the output. "        << endl << endl;

    Time t0;      // Default constructor (no parameters) invoked
    Time t1(12);  // One-parameter constructor invoked
    Time t2(11, 45);      // Two-parameter constructor invoked
    Time t3(11, 44, 55);  // Three-parameter constructor invoked
    cout << t0;  cout << endl;  // Overloaded << operator used with cout
    cout << t1;  cout << endl;
    cout << t2 << setw(12) << t3;  cout << endl;  // How does setw work?
    Pause(0);

    while (t3 < t2)  // Overloaded == operator
    {
        cout << t3;  cout << endl;
        t3.Increment();
    }
    if (t3 == t2)
        cout << "\nt2: " << t2 << "\nt3: " << t3 << endl;
    Pause(0);

    Time t4 = t1 + t2;  // Overloaded + operator used in initialization
    Time t5;
    t5 = t1 + t3;       // Overloaded + operator used in assignment
    cout << t4;  cout << endl;
    cout << t5;  cout << endl;
    Pause(0);

    ofstream outFile("times.tmp");
    outFile << t1 << endl // Overloaded << operator used with outFile
            << t2 << endl // Cascading of output values, i.e.,
            << t3 << endl // ... << value1 << value2 << value3 << ...
            << t4 << endl
            << t5 << endl;
    outFile.close();

    ifstream inFile("times.tmp");
    Time t;
    inFile >> t;
    while (inFile)
    {
        cout << t << endl;
        inFile >> t;
    }
    inFile.close();
    Pause(0);

    inFile.open("times.tmp");
    // Overloaded >> operator used with inFile
    // Cascading of input values (... >> value1 >> value2 >> value3 ...)
    inFile >> t1 >> t2 >> t3 >> t4 >> t5;
    inFile.close();
    cout << t1 << "  "
         << t2 << "  "
         << t3 << "  "
         << t4 << "  "
         << t5 << endl;

    return 0;
}
